#include<cstdio>
#include<vector>
#include<set>
#include<map>
#include<queue>
#include<algorithm>
#include<string>
#include<utility>
#include<cassert>
#include<cstring>
using namespace std;

#define REP(i,a,b) for(i=a;i<b;i++)
#define rep(i,n) REP(i,0,n)

int N;
char tar[120][120];
char mp[120][120];

int res[14400][5], res_size;
int now[14400][5], now_size;

void solve_simplest(void){
  int i, j, k, l, r, c;

  now_size = 0;
  rep(i,N) rep(j,N) mp[i][j] = 0;

  rep(i,N) rep(j,N) if(mp[i][j] != tar[i][j]){ /* this cell must be reversed */
    REP(c,j,N) if(mp[i][c] == tar[i][c]) break;
    REP(r,i,N){
      REP(k,j,c) if(mp[r][k] == tar[r][k]) break;
      if(k<c) break;
    }

    REP(k,i,r) REP(l,j,c) mp[k][l] ^= 1;
    
    now[now_size][0] = i;
    now[now_size][1] = j;
    now[now_size][2] = r-1;
    now[now_size][3] = c-1;
    now[now_size][4] = 'F';
    now_size++;
  }

  if(res_size > now_size){
    res_size = now_size;
    rep(i,res_size) rep(j,5) res[i][j] = now[i][j];
  }
}

int main(){
  int i, j, k;

  assert( scanf("%d",&N)==1 );
  assert( 10<=N && N<=50 );
  rep(i,N) assert( scanf("%s",tar[i])==1 );

  rep(i,N) assert( strlen(tar[i])==N );
  rep(i,N) rep(j,N) assert( tar[i][j]=='W' || tar[i][j]=='B' );

  rep(i,N) rep(j,N){
    if(tar[i][j]=='W') tar[i][j] = 0;
    else               tar[i][j] = 1;
  }

  res_size = N*N+1;
  solve_simplest();

  printf("%d\n",res_size);
  rep(i,res_size) printf("%d %d %d %d %c\n",res[i][0],res[i][1],res[i][2],res[i][3],res[i][4]);

  return 0;
}
